using System;
using System.Collections;
using Views;

class Till {

  /// <summary>
  /// The Till program     Bishop and Horspool     2002
  /// ================     
  ///                      C# and Views version May 2002
  ///                      Picture buttons N Ros March 2001
  ///                      updated August 2000
  ///                      original in Java Oct 1996
  ///                      Java 1.1 Abbott and Bishop Oct 1997
  ///                      
  /// Simulates a supermarket till; Illustrates advanced features
  /// of Views as well as managing linked events.
  /// </summary>

    Views.Form form;
    
    // tally variables
    double total, kg;
    int select = 1;
    const int maxProducts = 12;
    
    // managing variables
    bool chosen = false;
    bool weighed = false;
    
    // arrays
    double[] unitCost =  {2,3,5,2.5,3,7,10,6,2,4,4,4};
    string[] item = {"Apples", "Pears", "Grapes", "Oranges",
                    "Lemons", "Kiwis", "Avocados", "Strawberries",
                    "Bananas", "Peaches", "Plums", "Apricots"};
    string[] formParameters = new string[maxProducts*2];

    string tillGUISpec = @"<Form Text='FruitStop Till'>
      <vertical>
        <horizontal>
          <Label Text='     Mass ' Width=80/>
          <TextBox Name=weight Width=75/>
          <Button Name=Weigh/>
        </horizontal>
        <horizontal height=5/>
        <horizontal>
          <vertical>
            <Button Name={0} Image={1} Width=60 Height=60/>
            <Button Name={2} Image={3} Width=60 Height=60/>
            <Button Name={4} Image={5} Width=60 Height=60/>
          </vertical>
          <vertical>
            <Button name={6} Image={7} Width=60 Height=60/>
            <Button name={8} Image={9} Width=60 Height=60/>
            <Button name={10} Image={11} Width=60 Height=60/>
          </vertical>
          <vertical>
            <Button name={12} Image={13} Width=60 Height=60/>
            <Button name={14} Image={15} Width=60 Height=60/>
            <Button name={16} Image={17} Width=60 Height=60/>
          </vertical>
          <vertical>
           <Button name={18} Image={19} Width=60 Height=60/>
           <Button name={20} Image={21} Width=60 Height=60/>
           <Button name={22} Image={23} Width=60 Height=60/>
          </vertical>
        </horizontal>
        <horizontal height=5/>
        <horizontal>
          <Label Text='     Cost' Width=80/>
          <TextBox Name=cost Width=75/>
          <Button Name=Print/>
        </horizontal>
        <horizontal>
          <vertical width=75>
            <horizontal>
              <Label Text='Output' />
              <TextBox Name=message Width=180/>
            </horizontal>
          </vertical>
        </horizontal>
      </vertical>
    </Form>";

  void Go() {
    // Set up the Views parameter
    for (int count=0; count < maxProducts; count++) {
      formParameters[2*count] = item[count];
      formParameters[2*count+1] = item[count] + ".gif";
    } 

    form = new Views.Form(tillGUISpec, formParameters);
    form.PutText("message", "The till is open");
    for ( ; ; ) {
      string c = form.GetControl();
      if (c == null) break;
      ActionPerformed(c);
    } 
    form.CloseGUI();
  }
    void ActionPerformed( string c ) {
        switch(c) {
          case "Weigh":
            weighItem();
            break;
          case "Print":
            printCost();
            break;
          default :
            chooseItem(c);
            break;
        }
    }

    void weighItem() {
      kg = double.Parse(form.GetText("weight"));
      weighed = true;
    } 

    void chooseItem( string c ) {
      form.PutText("message", c+" was selected.");
      if (weighed) {
        select = Array.IndexOf(item,c); // see Chap 8 for this one
        chosen = true;
      } else
        form.PutText("message", "First weigh the items");
    } 

    void printCost() {
      if (chosen) {
        total = kg*unitCost[select];
        form.PutText("cost", "R "+total);
        form.PutText("message", kg+"kg "+
          item[select]+" @ "+unitCost[select]+
          " = R"+total);
        //resetting the variables
        kg      = 0;
        weighed = false;
        chosen  = false;
        total   = 0;
      } else
        form.PutText("message", "First choose an item!");
    }
    static void Main() {
      new Till().Go();
    }
}
